#include <bits/stdc++.h>
#define MAXN 1000005
using namespace std;

bool ok[MAXN];

int main()
{ int w,h,r,q,x,y,t;
scanf("%d%d%d%d",&w,&h,&r,&q);

while(q--)
{
    scanf("%d",&t);

    if(t==1)
    {
        scanf("%d%d",&x,&y);

        if( (y-r)<h ) ok[x]=true;
    }

    if(t==2)
    {
        scanf("%d",&x);

        if(ok[x]==true) printf("%d\n",h-1);
        else printf("%d\n",h);
    }
}
    return 0;
}